/*****************************************************************************/
/*!
 *\file datatype_theorem_producer.cpp
 *\brief TRUSTED implementation of recursive datatype rules
 *
 * Author: Clark Barrett
 *
 * Created: Mon Jan 10 15:43:39 2005
 *
 * <hr>
 * Copyright (C) 2003 by the Board of Trustees of Leland Stanford
 * Junior University and by New York University. 
 *
 * License to use, copy, modify, sell and/or distribute this software
 * and its documentation for any purpose is hereby granted without
 * royalty, subject to the terms and conditions defined in the \ref
 * LICENSE file provided with this distribution.  In particular:
 *
 * - The above copyright notice and this permission notice must appear
 * in all copies of the software and related documentation.
 *
 * - THE SOFTWARE IS PROVIDED "AS-IS", WITHOUT ANY WARRANTIES,
 * EXPRESSED OR IMPLIED.  USE IT AT YOUR OWN RISK.
 * 
 * <hr>
 * 
 */
/*****************************************************************************/


// This code is trusted
#define _CVCL_TRUSTED_


#include "datatype_theorem_producer.h"
#include "theory_datatype.h"
#include "theory_core.h"


using namespace std;
using namespace CVCL;


////////////////////////////////////////////////////////////////////
// TheoryDatatype: trusted method for creating DatatypeTheoremProducer
////////////////////////////////////////////////////////////////////


DatatypeProofRules*
TheoryDatatype::createProofRules(VCL* vcl, TheoryDatatype* theoryDatatype) {
  return new DatatypeTheoremProducer(vcl, theoryDatatype);
}
  

////////////////////////////////////////////////////////////////////
// Proof rules
////////////////////////////////////////////////////////////////////


#define CLASS_NAME "CVCL::DatatypeTheoremProducer"
