/*****************************************************************************/
/*!
 *\file datatype_theorem_producer.h
 *\brief TRUSTED implementation of recursive datatype proof rules
 *
 * Author: Clark Barrett
 *
 * Created: Mon Jan 10 15:42:22 2005
 *
 * <hr>
 * Copyright (C) 2003 by the Board of Trustees of Leland Stanford
 * Junior University and by New York University. 
 *
 * License to use, copy, modify, sell and/or distribute this software
 * and its documentation for any purpose is hereby granted without
 * royalty, subject to the terms and conditions defined in the \ref
 * LICENSE file provided with this distribution.  In particular:
 *
 * - The above copyright notice and this permission notice must appear
 * in all copies of the software and related documentation.
 *
 * - THE SOFTWARE IS PROVIDED "AS-IS", WITHOUT ANY WARRANTIES,
 * EXPRESSED OR IMPLIED.  USE IT AT YOUR OWN RISK.
 * 
 * <hr>
 * 
 * CLASS: DatatypeTheoremProducer
 * 
 */
/*****************************************************************************/
#ifndef _cvcl__theory_datatype__datatype_theorem_producer_h_
#define _cvcl__theory_datatype__datatype_theorem_producer_h_

#include "datatype_proof_rules.h"
#include "theorem_producer.h"
#include "vcl.h"
#include "theory_datatype.h"

namespace CVCL {
  
class DatatypeTheoremProducer: public DatatypeProofRules, public TheoremProducer {
    ExprManager* d_em;
    TheoryDatatype* d_theoryDatatype;
  private:
  public:
    //! Constructor
    DatatypeTheoremProducer(VCL* vcl, TheoryDatatype* theoryDatatype) :
      TheoremProducer(vcl->getTM()), d_em(vcl->getEM()),
      d_theoryDatatype(theoryDatatype) { }

  }; // end of class DatatypeTheoremProducer
} // end of namespace CVCL

#endif

